// TbEdit.h : Declaration of the CTbEdit
#pragma once

#include <atlapp.h>
#include <atlctrls.h>

const int WM_DOSEARCH = WM_USER + 1024;
class CToolBand;

/////////////////////////////////////////////////////////////////////////////
// CTbEdit
class CTbEdit : public CWindowImpl<CTbEdit,CEdit>
{
// External Interface
public:

	CTbEdit();
	virtual ~CTbEdit();

	BEGIN_MSG_MAP(CTbEdit)
		COMMAND_CODE_HANDLER(EN_SETFOCUS, OnSetFocus)
	END_MSG_MAP()

	LRESULT OnSetFocus(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);

	STDMETHOD(TranslateAcceleratorIO)(LPMSG lpMsg);
	inline void SetBand(CToolBand* pBand)		{m_pBand = pBand;}

// Data
private:
	CToolBand* m_pBand;
};
