// stdafx.h : include file for standard system include files,
// or project specific include files that are used frequently,
// but are changed infrequently

#pragma once

#ifndef STRICT
#define STRICT
#endif

// Modify the following defines if you have to target a platform prior to the ones specified below.
// Refer to MSDN for the latest info on corresponding values for different platforms.
#ifndef WINVER				// Allow use of features specific to Windows 95 and Windows NT 4 or later.
#define WINVER 0x0400		// Change this to the appropriate value to target Windows 98 and Windows 2000 or later.
#endif

#ifndef _WIN32_WINNT		// Allow use of features specific to Windows NT 4 or later.
#define _WIN32_WINNT 0x0400	// Change this to the appropriate value to target Windows 2000 or later.
#endif						

#ifndef _WIN32_WINDOWS		// Allow use of features specific to Windows 98 or later.
#define _WIN32_WINDOWS 0x0410 // Change this to the appropriate value to target Windows Me or later.
#endif

// assume IE 5.x is installed
#ifdef _WIN32_IE
 #undef _WIN32_IE
#endif
#define	_WIN32_IE		0x0501

#define _ATL_APARTMENT_THREADED
#define _ATL_NO_AUTOMATIC_NAMESPACE

#define _ATL_CSTRING_EXPLICIT_CONSTRUCTORS	// some CString constructors will be explicit

// turns off ATL's hiding of some common and often safely ignored warning messages
#define _ATL_ALL_WARNINGS

#define ISOLATION_AWARE_ENABLED 1

#include "resource.h"
#include <atlbase.h>
#include <atlcom.h>

using namespace ATL;

#include <atlapp.h>
#include <atlwin.h>
#include <atlmisc.h>

// extra stuff from Windows that we need
#include <CommCtrl.h>
#include <ShellApi.h>
#include <Tchar.h>
#include <comdef.h>
#include <comutil.h>

// use the default Microsoft STL 
#include <algorithm>
#include <list>
#include <map>
#include <set>
#include <string>
#include <stack>
#include <vector>
#include <queue>

// create our generic string type, 'tstring'
typedef std::basic_string<wchar_t>	ustring;	// Unicode string
typedef std::basic_string<char>		astring;	// ANSI/Multibyte string
//
#ifdef _UNICODE
  typedef ustring tstring;
#else
  typedef astring tstring;
#endif

extern HINSTANCE g_hInstance;

// return the number of elements in a statically declared array
#define ARRAY_COUNT( a )		(sizeof(a)/sizeof(a[0]))
#define BAD_INDEX				(-1)
