// tb4ie.cpp : Implementation of DLL Exports.

#include "stdafx.h"
#include "resource.h"
#include "tb4ie.h"

class Ctb4ieModule : public CAtlDllModuleT< Ctb4ieModule >
{
public :
	DECLARE_LIBID(LIBID_tb4ieLib)
	DECLARE_REGISTRY_APPID_RESOURCEID(IDR_TB4IE, "{0CAA21FF-5CE0-462F-B6D4-DCE78D4FB54B}")
};

Ctb4ieModule _AtlModule;
// add manually
HINSTANCE	 g_hInstance;
//

// DLL Entry Point
extern "C" BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	BOOL rc = FALSE;
    rc = _AtlModule.DllMain(dwReason, lpReserved); 
    if (dwReason == DLL_PROCESS_ATTACH)
    {
		g_hInstance = hInstance;
        DisableThreadLibraryCalls(hInstance);
    }
	return rc;
}

// Used to determine whether the DLL can be unloaded by OLE
STDAPI DllCanUnloadNow(void)
{
    return _AtlModule.DllCanUnloadNow();
}


// Returns a class factory to create an object of the requested type
STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
    return _AtlModule.DllGetClassObject(rclsid, riid, ppv);
}


// DllRegisterServer - Adds entries to the system registry
STDAPI DllRegisterServer(void)
{
    // add manually
	HKEY hKeyLocal = NULL;
	RegCreateKeyEx(HKEY_LOCAL_MACHINE, _T("Software\\Microsoft\\Internet Explorer\\Toolbar"), 0, NULL, REG_OPTION_NON_VOLATILE, KEY_WRITE, NULL, &hKeyLocal, NULL);
	//	CoToolBand Class uuid(0A951C61-2A70-4FEC-8092-9DCBCEA87D09),
	RegSetValueEx(hKeyLocal, _T("{0A951C61-2A70-4FEC-8092-9DCBCEA87D09}"), 0, REG_BINARY, NULL, 0);
	RegCloseKey(hKeyLocal);
	//
    // registers object, typelib and all interfaces in typelib
    HRESULT hr = _AtlModule.DllRegisterServer();
	return hr;
}


// DllUnregisterServer - Removes entries from the system registry
STDAPI DllUnregisterServer(void)
{
    // add manually
	HKEY hKeyLocal = NULL;
	RegCreateKeyEx(HKEY_LOCAL_MACHINE, _T("Software\\Microsoft\\Internet Explorer\\Toolbar"), 0, NULL, REG_OPTION_NON_VOLATILE, KEY_WRITE, NULL, &hKeyLocal, NULL);
	RegDeleteValue(hKeyLocal, _T("{0A951C61-2A70-4FEC-8092-9DCBCEA87D09}"));
	RegCloseKey(hKeyLocal);
	//
	HRESULT hr = _AtlModule.DllUnregisterServer();
	return hr;
}
