//ReflectionWnd.h : Declaration of the CReflectionWnd

#pragma once

#include <atlapp.h>
#include <atlctrls.h>

#include "CustomToolbar.h"

/////////////////////////////////////////////////////////////////////////////
// CReflectionWnd
// It is used for reflecting messages to the toolbar control
// 
class CReflectionWnd : public CWindowImpl<CReflectionWnd>
{
// External Interface
public:

	CReflectionWnd();
	virtual ~CReflectionWnd();

	DECLARE_WND_CLASS(_T("WorkerW"))

	BEGIN_MSG_MAP( CReflectionWnd )
        MESSAGE_HANDLER( WM_CREATE, OnCreate )
		CHAIN_MSG_MAP_MEMBER(m_toolbar)
	END_MSG_MAP()

	LRESULT OnCreate(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& /*bHandled*/);
	CCustomToolbar*	GetToolbarPtr()	{ return &m_toolbar; }

// Data
protected:

	CCustomToolbar	m_toolbar;	// custom toolbar
};
